package gui;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.Hashtable;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.text.AbstractDocument;

import server.LoginException;

import net.ConnectionInfo;
import net.TimeoutLimitException;

import client.ClientGuiListener;
import client.FachadaClient;
import client.Inicializador;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * LoginScreen.java
 *
 * Created on 02/06/2011, 09:59:22
 */

/**
 *
 * @author patmc
 */
public class LoginScreen extends javax.swing.JFrame{
    static Registro regWindow;
    static Sobre aboutWindow;
    static FriendList friendListWindow;
    private FachadaClient fachada;
    /** Creates new form LoginScreen */
    public LoginScreen() { 
    	this.regWindow = new Registro();
        this.aboutWindow = new Sobre();
        try {
			fachada = new Inicializador().getFachada();
			regWindow.setFachada(fachada);
		} catch (SocketException e) {
			this.mostraErro(e.getMessage());
			System.exit(0);
		} catch (UnknownHostException e) {
			this.mostraErro("Host Desconhecido: "+e.getMessage());
			System.exit(0);		
		} catch (IOException e) {
			this.mostraErro(e.getMessage());
			System.exit(0);	
		} catch (ClassNotFoundException e) {
			this.mostraErro(e.getMessage());
			System.exit(0);	
		}
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		 initComponents();  
    }
    public void mostraErro(String error){
    	JOptionPane.showMessageDialog(null, error);
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        senhaField = new javax.swing.JPasswordField();
        loginField = new javax.swing.JTextField();
        entrarButton = new javax.swing.JButton();
        loginLabel = new javax.swing.JLabel();
        senhaLabel = new javax.swing.JLabel();
        registrarButton2 = new javax.swing.JButton();
        bearImage = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        arquivoMenu = new javax.swing.JMenu();
        registrarButton = new javax.swing.JMenuItem();
        sobreButton = new javax.swing.JMenuItem();
        sairButton = new javax.swing.JMenuItem();

        
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Bear Talk");
        setBackground(new java.awt.Color(255, 255, 255));
        setForeground(java.awt.Color.white);
        setName(""); // NOI18N
        setResizable(false);

        AbstractDocument doc2 = (AbstractDocument) senhaField.getDocument();
        doc2.setDocumentFilter(new DocumentSizeFilter(10));
        senhaField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                senhaFieldActionPerformed(evt);
            }
        });

        AbstractDocument doc = (AbstractDocument) loginField.getDocument();
        doc.setDocumentFilter(new DocumentSizeFilter(10));
        loginField.setToolTipText("Login");
        loginField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loginFieldActionPerformed(evt);
            }
        });

        entrarButton.setText("Entrar!");
        entrarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                entrarButtonActionPerformed(evt);
            }
        });

        loginLabel.setText("Login:");

        senhaLabel.setText("Senha:");

        registrarButton2.setText("Registrar-se");
        registrarButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                registrarButton2ActionPerformed(evt);
            }
        });

        bearImage.setIcon(new javax.swing.ImageIcon("beartalk.jpg")); // NOI18N

        arquivoMenu.setText("Arquivo");

        registrarButton.setText("Registrar");
        registrarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                registrarButtonActionPerformed(evt);
            }
        });
        arquivoMenu.add(registrarButton);

        sobreButton.setText("Sobre...");
        sobreButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sobreButtonActionPerformed(evt);
            }
        });
        arquivoMenu.add(sobreButton);

        sairButton.setText("Sair");
        sairButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sairButtonActionPerformed(evt);
            }
        });
        arquivoMenu.add(sairButton);

        menuBar.add(arquivoMenu);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(34, 34, 34)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(loginLabel)
                            .addComponent(senhaLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(loginField)
                            .addComponent(senhaField, javax.swing.GroupLayout.DEFAULT_SIZE, 164, Short.MAX_VALUE)
                            .addComponent(entrarButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(registrarButton2, javax.swing.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addComponent(bearImage)))
                .addContainerGap(22, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(bearImage)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(loginLabel)
                    .addComponent(loginField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(senhaField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(senhaLabel))
                .addGap(35, 35, 35)
                .addComponent(entrarButton)
                .addGap(18, 18, 18)
                .addComponent(registrarButton2)
                .addGap(32, 32, 32))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void entrarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_entrarButtonActionPerformed
        String login = this.loginField.getText();
    	String senha = String.valueOf(this.senhaField.getPassword());
    	if(login.equals("") || senha.equals("") || senha == null || login == null){
    		this.mostraErro("Favor preencher campos obrigatrios!");
    	}else{
    		try {
				this.fachada.logar(login, senha);
				friendListWindow = new FriendList(loginField.getText(), fachada);
	            friendListWindow.setVisible(true);
	            this.dispose();
			} catch (TimeoutLimitException e) {
				this.mostraErro(e.getMessage());
			} catch (LoginException e) {
				this.mostraErro(e.getMessage());
			}	
    	}
    	
    }//GEN-LAST:event_entrarButtonActionPerformed

    private void loginFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loginFieldActionPerformed
    	  String login = this.loginField.getText();
      	String senha = String.valueOf(this.senhaField.getPassword());
      	if(login.equals("") || senha.equals("") || senha == null || login == null){
      		this.mostraErro("Favor preencher campos obrigatrios!");
      	}else{
      		try {
  				this.fachada.logar(login, senha);
  				friendListWindow = new FriendList(loginField.getText(), fachada);
  	            friendListWindow.setVisible(true);
  	            this.dispose();
  			} catch (TimeoutLimitException e) {
  				this.mostraErro(e.getMessage());
  			} catch (LoginException e) {
  				this.mostraErro(e.getMessage());
  			}	
      	}  
      	}//GEN-LAST:event_loginFieldActionPerformed

    private void registrarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_registrarButtonActionPerformed
       
    	
    	this.regWindow.setVisible(true);
    }//GEN-LAST:event_registrarButtonActionPerformed

    private void registrarButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_registrarButton2ActionPerformed
        this.regWindow.setVisible(true);
    }//GEN-LAST:event_registrarButton2ActionPerformed

    private void sobreButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sobreButtonActionPerformed
        this.aboutWindow.setVisible(true);
    }//GEN-LAST:event_sobreButtonActionPerformed

    private void sairButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sairButtonActionPerformed
        System.exit(0);
}//GEN-LAST:event_sairButtonActionPerformed

    private void senhaFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_senhaFieldActionPerformed
  	  String login = this.loginField.getText();
    	String senha = String.valueOf(this.senhaField.getPassword());
    	if(login.equals("") || senha.equals("") || senha == null || login == null){
    		this.mostraErro("Favor preencher campos obrigatrios!");
    	}else{
    		try {
				this.fachada.logar(login, senha);
				friendListWindow = new FriendList(loginField.getText(), fachada);
	            friendListWindow.setVisible(true);
	            this.dispose();
			} catch (TimeoutLimitException e) {
				this.mostraErro(e.getMessage());
			} catch (LoginException e) {
				this.mostraErro(e.getMessage());
			}	
    	}  
        
    }//GEN-LAST:event_senhaFieldActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LoginScreen().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu arquivoMenu;
    private javax.swing.JLabel bearImage;
    private javax.swing.JButton entrarButton;
    private javax.swing.JTextField loginField;
    private javax.swing.JLabel loginLabel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem registrarButton;
    private javax.swing.JButton registrarButton2;
    private javax.swing.JMenuItem sairButton;
    private javax.swing.JPasswordField senhaField;
    private javax.swing.JLabel senhaLabel;
    private javax.swing.JMenuItem sobreButton;
    // End of variables declaration//GEN-END:variables

}
